/*
 * oscp-slave-gme.c
 * Copyright (C) 2015 KotCzarny <tjosko@yahoo.com>
 *
 *  This program is free software; you can redistribute it and/or modify it
 *  under the terms of the GNU General Public License as published by the
 *  Free Software Foundation; either version 2 of the License, or (at your
 *  option) any later version.
 *
 *  This program is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */

#include "oscp-slave.h"

#include <gme/gme.h>

Music_Emu * gmec; gme_info_t *gmeI;

#define gme_dbuf_size 1024*2
char gme_dbuf[gme_dbuf_size];

int gmestate=0; float gmecur=0, gmedur=0; int gmei=0;
int gmesong=0; int gmedurmax=5;

/////################
void gme_show_supp() {
 printf("  [slave-gme]: based on gme-0.6.0");
 printf(", formats: ay, gbs, gym, hes, kss, nsf, nsfe, sap, spc, vgm\n");
}

/////###########
//void gme_flush() { lf("gme_flush"); adev_flush(); }
/////###########
void gme_init() { lf("gme_init"); gmestate=0; dlog(9, "gme_init"); if(gmestate>0) return;

 if(gmec) dlog(9, "gme_init: gmec not null?");

// gmec=gmedec_new();

 if(adev_init()<=0) { gmestate=0; return; }

 gmestate=1;
}
/////##########
void gme_stop() { lf("gme_stop");
 dlog(9, "gme_stop");
 if(gmestate<=1) return;

 if(gmestate>=3) { 
  if(gmec) gme_delete(gmec);
//  gmedec_restart(gmec);
 }

 gmestate=1;
}
/////#########
void gme_end() { lf("gme_end");
 dlog(9, "gme_end"); if(gmestate>1) gme_stop(); adev_end();

 gmestate=0; 
}
/////##################
void gme_die(char *msg) { lf2("gme_die",msg); dlog(9, "gme_die"); gme_stop(); cs(msg); }

char gmefn[PATH_MAX]; int gmefs=0;

/////#####################################
void gme_update_info(char *fn, char *type) { lf("gme_update_info");
 static char lmsg[4096];

 char *gerr=(char *)gme_track_info(gmec, &gmeI, 0);
 if(gerr) { dlog(9,gerr); } else dlog(9,"gme_track_info ok");
/*
sprintf(lmsg, "length: %d", gmeI->length/1000); dlog(9,lmsg);
sprintf(lmsg, "play_length: %d", gmeI->play_length/1000); dlog(9,lmsg);
sprintf(lmsg, "system: %s", gmeI->system); dlog(9,lmsg);
sprintf(lmsg, "game: %s", gmeI->game); dlog(9,lmsg);
sprintf(lmsg, "song: %s", gmeI->song); dlog(9,lmsg);
sprintf(lmsg, "author: %s", gmeI->author); dlog(9,lmsg);
sprintf(lmsg, "copyright: %s", gmeI->copyright); dlog(9,lmsg);
sprintf(lmsg, "comment: %s", gmeI->comment); dlog(9,lmsg);
sprintf(lmsg, "dumper: %s", gmeI->dumper); dlog(9,lmsg);
*/

 gmedur=gmeI->play_length/1000; if(gmedur<=0) gmedur=gmedurmax;
 sprintf(lmsg, "ANS_length=%.1f\n", gmedur); cs(lmsg);

 snprintf(lmsg,1022,"Title: %s (%s)\n", gmeI->game, get_basename(fn)); cs(lmsg);
 int fs=get_filesize(fn);
 snprintf(lmsg,1022,"Comment: %d,%s,%s,%s,%s,%s,%s\n", fs, type
,gmeI->song
,gmeI->system
,gmeI->comment
,gmeI->copyright
,gmeI->dumper

 ); cs(lmsg);

 gme_free_info(gmeI);
}

void gme1_play();
/////###############################
void gme_load(char *input_filename0) { lfd("gme_load:state",gmestate);
 static char lmsg[4096]; lmsg[4095]=0;
 snprintf(lmsg, 4095, "Playing %s\n", input_filename0); cs(lmsg);

 if(input_filename0[0]==0) return;
 if(input_filename0[0]==*"\"" && input_filename0[1]==*"\"" && input_filename0[2]==0)
 { cs("EOF code: stop requested\n"); if(gmestate>2) gme_stop(); return; }

 if(gmestate==0) gme_init();
 else if(gmestate>2) gme_stop();

 gmestate=2; gmecur=0; gmedur=0;

 char *input_filename=input_filename0;
// int ret=0;


 gmefs=get_filesize(input_filename);
 if(gmefs<=0) { gme_die("EOF code: invalid module size\n"); return; }

 char *module=malloc(gmefs); if(!gmefs) { gme_die("EOF code: malloc failed\n"); return; }
 FILE *f=fopen(input_filename, "r"); if(!f) { gme_die("EOF code: fopen failed\n"); return; }
 fread(module, gmefs, 1, f); fclose(f);

/* Determine likely game music type based on first four bytes of file. Returns
string containing proper file suffix (i.e. "NSF", "SPC", etc.) or "" if
file header is not recognized. */
//const char* gme_identify_header( void const* header );
 char *gmt=(char *)gme_identify_header(module);
 if(strcmp(gmt,"")==0)
 { free(module); gme_die("EOF code: gme_identify_header failed\n"); gme_stop(); return; }
 else dlog(9,gmt);

/* Create new emulator and set sample rate. Returns NULL if out of memory. If you only need
track information, pass gme_info_only for sample_rate. */
//Music_Emu* gme_new_emu( gme_type_t, int sample_rate );


/* Same as gme_open_file(), but uses file data already in memory. Makes copy of data. */
//gme_err_t
 char *gerr=(char *)gme_open_data(module, gmefs, &gmec, 44100);
 if(gerr) { dlog(9,gerr); gme_die("EOF code: gme_open_data failed\n"); return; }
 else dlog(9,"gme_open_data ok");

/* Load music file from memory into emulator. Makes a copy of data passed. */
//gme_err_t gme_load_data( Music_Emu*, void const* data, long size );

 free(module);

// if(ret!=0 || ret2!=0)
// if(ret==0 || ret2==0) {
//sprintf(lmsg, "gme fs:%d, ret0:%d, ret:%d, ret2:%d", gmefs, ret0, ret, ret2); dlog(9,lmsg);
// gme_die("EOF code: gme_load failed\n"); return; }

 sfmt=AV_SAMPLE_FMT_S16;
      if(sfmt==AV_SAMPLE_FMT_U8 || sfmt==AV_SAMPLE_FMT_U8P){ sformat.bits=8; }
 else if(sfmt==AV_SAMPLE_FMT_S16 || sfmt==AV_SAMPLE_FMT_S16P){ sformat.bits=16; }
 else if(sfmt==AV_SAMPLE_FMT_S32 || sfmt==AV_SAMPLE_FMT_S32P){ sformat.bits=32; }
 else if(sfmt==AV_SAMPLE_FMT_FLT || sfmt==AV_SAMPLE_FMT_FLTP){ sformat.bits=32; }
 else if(sfmt==AV_SAMPLE_FMT_DBL || sfmt==AV_SAMPLE_FMT_DBLP){ sformat.bits=64; }
 else { gme_die("EOF code: Unsupported format\n"); return; }

 gmecur=-1;
// gmedur=gmeInfo_GetDuration(gmeI, gmeInfo_GetDefaultSong(gmeI))/1000.0;

 sformat.channels=2; sformat.rate=44100;
#ifdef LAO
 sformat.byte_format=AO_FMT_NATIVE; sformat.matrix=0;
#endif

 adev_setp(sformat.bits, &sformat.channels, &sformat.rate);
sprintf(lmsg, "AUDIO: %d Hz, %d ch, xxx, %d kbit\n", sformat.rate, sformat.channels, 0); cs(lmsg);

 gme_update_info(input_filename, gmt);

 gmestate=3; gmei=1;
 gme1_play();
}
void oscp_gme_check_input();
void oscp_gme_parse(char *a);
/////################# check messages
void gme_check_input() { lf("gme_check_input"); static char lmsg[4096]; static int rc;
 static fd_set gmefsa;  static struct timeval gmetv,*tvp;
 if(gmestate==4) { tvp=NULL; }
 else { gmetv.tv_sec=0; gmetv.tv_usec=1; tvp=&gmetv; }

 FD_ZERO(&gmefsa); if(parent_said>=0) FD_SET(parent_said, &gmefsa);

 rc=select(FD_SETSIZE, &gmefsa, NULL, NULL, tvp); if(rc==0) return;
 else if(rc<0) { sprintf(lmsg, "Info: gmeci rc<0, %d, %s\n", errno, strerror(errno)); cs(lmsg); }
 else if(rc>0) // check if input is available
 { fdreadline(parent_said, lmsg, 1020); oscp_gme_parse(lmsg); }
}
/////###################
void gme_pause_toggle() { lf("gme_pause_toggle");
      if(gmestate==3) { gmestate=4; cs("===== PAUSE =====\n");
  do { oscp_gme_check_input(); } while(gmestate==4);
 }
 else if(gmestate==4) { gmestate=3; cs("===== RESUME =====\n"); }
 else cs("Info: pause called but gmestate != (3 || 4)"); }

/////##############
void gme_checksd() {}
/////##############
void gme_checkmd() {}

/////###########
void gme1_play() { lf("gme1_play"); dlog(9, "gme_play");
 if(gmestate!=3) { cs("EOF code: can't play, not inited\n"); return; }
 float ot1=-7.0, ts=((float)gme_dbuf_size)/44100.0/2.0/2.0;

 static char lmsg[128]; void *buf[1];

 buf[0]=gme_dbuf;
 short int *buf2=(short int *)gme_dbuf; char *gerr=NULL;

 gerr=(char *)gme_start_track(gmec, 0);
 if(gerr) { dlog(9,gerr); }

 while(gmestate==3 && (gerr=(char *)gme_play(gmec, gme_dbuf_size/2, buf2))==NULL
 && gme_track_ended(gmec)==0 && gmecur<=gmedur
)
 {
  gmecur+=ts; if((int)gmecur!=(int)ot1)
  { ot1=gmecur; sprintf(lmsg, "A: %.1f 0 0 0 0 0 0 0\n", gmecur); cs(lmsg); }

  adev_out(buf, gme_dbuf_size/2/sformat.channels, sformat.channels, sfmt);

  gmei++; gme_check_input();
 } if(gerr!=NULL) dlog(9,gerr);

 adev_close();
 gme_die("EOF code: finished decoding\n");
 lf("gme1_play:finished");
}

/////########################
void oscp_gme_load(char *fn) { lf("oscp_gme_load");
 gme_load(fn); //gme1_play();
 lf("oscp_gme_load:finished");
}
/////#####################
void oscp_gme_seek(int a) { lf("oscp_gme_seek"); int t=gmecur+a; if(t<0) t=0;
 gme_seek(gmec, t*1000.0); gmecur=gme_tell(gmec)/1000;
}
/////########################
void oscp_gme_parse(char *a) { lf("oscp_gme_parse"); char lmsg[4096];
// sprintf(lmsg,"ofparse start"); dlog(9,lmsg);
 int l=strlen(a); if(l<=0) { sprintf(lmsg,"ofparse: l==%d ?", l); dlog(9,lmsg); return; }
 if(strcmp(a,"q")==0 || strcmp(a,"quit")==0) { gme_end(); exit(0);
 } else if(strncmp(a,"loadfile ",9)==0) { oscp_gme_load(a+9);
 } else if(strncmp(a,"load ",5)==0) { oscp_gme_load(a+5);
 } else if(strncmp(a,"pause",5)==0) { gme_pause_toggle();
 } else if(strncmp(a,"get_property length",19)==0) {
  sprintf(lmsg, "ANS_length=%.1f\n", gmedur); cs(lmsg);
 } else if(strncmp(a,"get_property time_pos",19)==0 || strncmp(a,"get_time_pos",12)==0) {
//  sprintf(lmsg, "A: %.1f 0 0 0 0 0 0 0 0 0\n", gmecur); cs(lmsg);
 } else if(strncmp(a,"seek ",5)==0) { int o1=0;
  if(a[5]==*"-") { sscanf(a+6, "%d", &o1); o1*=-1; }
  else if(a[5]==*"+") { sscanf(a+6, "%d", &o1); }
  else { sscanf(a+5, "%d", &o1); }
  oscp_gme_seek(o1);
 } else if(strncmp(a,"vis ",4)==0) { sscanf(a+4, "%d", &vis);
 } else if(strncmp(a,"lfdump",5)==0) { lfdump();
 } else { sprintf(lmsg, "ofparse unhandled: %s", a); dlog(9, lmsg); }
 lf("oscp_gme_parse:finished");
}
/////####################### check stdin
void oscp_gme_check_input() { lf("oscp_gme_check_input");
 char lmsg[4096]; int i, rc; fd_set fsa;
 struct timeval *tvp=NULL; //, tv; tv.tv_sec=0; tv.tv_usec=10000*99; // i=(int)time(NULL);
 usleep(10000); FD_ZERO(&fsa); if(parent_said>=0) FD_SET(parent_said, &fsa);
 rc=select(FD_SETSIZE, &fsa, NULL, NULL, tvp); // block till input

 if(rc<0) { if(0) { exit(EXIT_FAILURE); } else usleep(10000*99); }
 else if(rc==0) { }
 else for(i=0; i<FD_SETSIZE; ++i) if(FD_ISSET(i, &fsa)) {
  if(i==parent_said) { fdreadline(i, lmsg, 1020); oscp_gme_parse(lmsg); }
 }
 lf("oscp_gme_check_input:finished");
}
////################
int oscp_gme_main() { lf("oscp_gme_main");
 cs("oscp-slave gme 1.0.3\n");
 lf("oscp_gme_main:gme_init");
 gme_init();
 lf("oscp_gme_main:while");
 while(1) { oscp_gme_check_input(); }
 lf("oscp_gme_main:gme_end");
 gme_end();
 lf("oscp_gme_main:finished");
 cs("EOF code: exit\n");
// lfdump();
 return 0;
}
