/*
 * oscp-slave-timi-forktimidity++.c
 * Copyright (C) 2015 KotCzarny <tjosko@yahoo.com>
 *
 *  This program is free software; you can redistribute it and/or modify it
 *  under the terms of the GNU General Public License as published by the
 *  Free Software Foundation; either version 2 of the License, or (at your
 *  option) any later version.
 *
 *  This program is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */

#include "oscp-slave.h"

#include <sys/types.h> //socketpair
#include <sys/socket.h> //socketpair
#include <signal.h> //signal
#include <sys/time.h> //setpriority
#include <sys/resource.h> //setpriority


#define timi_dbuf_size 1024*2
char timi_dbuf[timi_dbuf_size];

int timistate=0; float timicur=0, timidur=0; int timii=0; int timisong=0;
char timifn[PATH_MAX]; int timifs=0;
float timidurmax=245;

int timi_send[2], timi_recv[2], timi_recv2[2]; // fds
int timi_pid=-1;

/////################
void timi_show_supp() {
 printf("\n  [slave-timifork]: based on timidity++");
 printf(", formats: mid\n");
}

/////###########
//void timi_flush() { lf("timi_flush"); adev_flush(); }
/////###########
void timi_init() { lf("timi_init"); timistate=0; dlog(9, "timi_init"); if(timistate>0) return;

// if(timic) dlog(9, "timi_init: timic not null?");

 if(adev_init()<=0) { timistate=0; return; }

 timistate=1;
}
/////##########
void timi_stop() { lf("timi_stop");
 dlog(9, "timi_stop");
 if(timistate<=1) return;

 if(timistate>=3) {
  if(timi_send[1]>0) close(timi_send[1]); if(timi_recv[1]>0) close(timi_recv[1]);
  if(timi_recv2[1]>0) close(timi_recv2[1]);
  if(timi_pid>0) {
   if(kill(timi_pid,0)==0) { dlog(9,"timi_stop: Killing slave."); kill(timi_pid,SIGTERM); usleep(100000); }
   if(kill(timi_pid,0)==0) kill(timi_pid,SIGKILL);
   timi_pid=-1;
  }
 }

 timistate=1;
}
/////#########
void timi_end() { lf("timi_end");
 dlog(9, "timi_end"); if(timistate>1) timi_stop(); adev_end();

 timistate=0; 
}
/////##################
void timi_die(char *msg) { lf2("timi_die",msg); dlog(9, "timi_die"); timi_stop(); cs(msg); }



/////##########################
void timi_update_info(char *fn) { lf("timi_update_info");
 char lmsg[1024];
 int fs=get_filesize(fn);
 snprintf(lmsg,1023,"Title: %s\n", get_basename(fn)); cs(lmsg);
 snprintf(lmsg,1023,"Comment: %d, timi\n", fs); cs(lmsg);
}

////#########################
int timi_exec(char *mod_path) { lf("timi_exec"); dlog(9,"timi_exec");
 if(socketpair(AF_UNIX, SOCK_STREAM, 0, timi_send)<0) return -1;
 if(socketpair(AF_UNIX, SOCK_STREAM, 0, timi_recv)<0) return -1;
 if(socketpair(AF_UNIX, SOCK_STREAM, 0, timi_recv2)<0) return -1;

 signal(SIGPIPE, SIG_IGN); signal(SIGCHLD, SIG_IGN); // Ignore signal for death of the child process

 timi_pid = fork(); if(timi_pid == 0) // I am a child!
 { char lmsg[128]; sprintf(lmsg, "timi_exec: i am child (pid: %d)", timi_pid); dlog(9,lmsg);

  // pipe in/output through socket to parent
//  dup2(STDOUT_FILENO, STDERR_FILENO);  //redirects stderr to stdout
  dup2(timi_send[0], STDIN_FILENO);
  dup2(timi_recv[0], STDOUT_FILENO);
  dup2(timi_recv2[0], STDERR_FILENO);
  close(timi_send[1]); close(timi_recv[1]); close(timi_recv2[1]);
//  close(timi_recv2[0]);

  execlp("timidity-slave", "timidity-slave", "-idv",
  "--buffer-fragments=8,12", "--audio-buffer=2,100", "--polyphony=1024",
//"--sampling-freq=32000", "-EFreverb=0", "-EFchorus=0"
  "-OrSs1l", "-W-", "-o", "-",
  "slave", NULL);
//timidity-slave -idqqq --buffer-fragments=8,12 --audio-buffer=2,100 --polyphony=1024 -OrSs1l -W-
// -o - slave

  dlog(0,"timi_exec: execlp failed"); exit(-1);
 }

 // I am a parent!, use timi_xxx[1] to communicate
 close(timi_send[0]); close(timi_recv[0]); close(timi_recv2[0]);

 int ret=7; if(timi_pid==-1) // child is dead
 { if(timi_send[1]>0) close(timi_send[1]); if(timi_recv[1]>0) close(timi_recv[1]);
  if(timi_recv2[1]>0) close(timi_recv2[1]); timi_send[1]=timi_recv[1]=timi_recv2[1]=-1; ret=-1; }
 else // child is alive
 { setpriority(PRIO_PROCESS,timi_pid,-1); ret=0; }
 usleep(200000);

 return ret;
}

void timi_play();
/////################################
void timi_load(char *input_filename0) { lfd("timi_load:state",timistate);
 dlog(9, "timi_load"); if(input_filename0[0]==0) return;
 if(input_filename0[0]==*"\"" && input_filename0[1]==*"\"" && input_filename0[2]==0)
 { cs("EOF code: stop requested\n"); if(timistate>2) timi_stop(); return; }

 if(timistate==0) timi_init();
 else if(timistate>2) timi_stop();

 timistate=2; timicur=0; timidur=0;
 static char lmsg[4096]; lmsg[4095]=0;
 char *input_filename=input_filename0;
// int ret=0;

 snprintf(lmsg, 4095, "Playing %s\n", input_filename); cs(lmsg);

 timifs=get_filesize(input_filename);
 if(timifs<=0) { timi_die("EOF code: invalid module size\n"); return; }

 if(timi_exec(input_filename)!=0) { timi_die("timi_load: timi_exec failed"); return; }

 sfmt=AV_SAMPLE_FMT_S16;
      if(sfmt==AV_SAMPLE_FMT_U8 || sfmt==AV_SAMPLE_FMT_U8P){ sformat.bits=8; }
 else if(sfmt==AV_SAMPLE_FMT_S16 || sfmt==AV_SAMPLE_FMT_S16P){ sformat.bits=16; }
 else if(sfmt==AV_SAMPLE_FMT_S32 || sfmt==AV_SAMPLE_FMT_S32P){ sformat.bits=32; }
 else if(sfmt==AV_SAMPLE_FMT_FLT || sfmt==AV_SAMPLE_FMT_FLTP){ sformat.bits=32; }
 else if(sfmt==AV_SAMPLE_FMT_DBL || sfmt==AV_SAMPLE_FMT_DBLP){ sformat.bits=64; }
 else { timi_die("EOF code: Unsupported format\n"); return; }

 timicur=-1;

 sformat.channels=2; //(timiconf.playback==timi_stereo?2:1);
 sformat.rate=44100; //timiconf.frequency;
#ifdef LAO
 sformat.byte_format=AO_FMT_NATIVE; sformat.matrix=0;
#endif

 adev_setp(sformat.bits, &sformat.channels, &sformat.rate);
sprintf(lmsg, "AUDIO: %d Hz, %d ch, xxx, %d kbit\n", sformat.rate, sformat.channels, 0); cs(lmsg);

 timi_update_info(input_filename);

 timistate=3; timii=1;
 timi_play();
}
void oscp_timi_check_input();
void oscp_timi_parse(char *a);
/////################# check messages
void timi_check_input() { lf("timi_check_input"); static char lmsg[4096]; static int rc;
 static fd_set timifsa;  static struct timeval timitv,*tvp;
 if(timistate==4) { tvp=NULL; }
 else { timitv.tv_sec=0; timitv.tv_usec=1; tvp=&timitv; }

 FD_ZERO(&timifsa);
 if(parent_said>=0) FD_SET(parent_said, &timifsa);
 if(timi_recv2[1]>=0) FD_SET(timi_recv2[1], &timifsa);

 rc=select(FD_SETSIZE, &timifsa, NULL, NULL, tvp); if(rc==0) return;
 else if(rc<0) { sprintf(lmsg, "Info: timici rc<0, %d, %s\n", errno, strerror(errno)); cs(lmsg); }
 else if(rc>0) // check if input is available
 { int i;
  for(i=0; i<FD_SETSIZE; ++i) if(FD_ISSET(i, &timifsa)) {
   if(i==parent_said) { fdreadline(parent_said, lmsg, 1020); oscp_timi_parse(lmsg); }
   else if(i==timi_recv2[1]) { fdreadline(i, lmsg, 1020);
// oscp_timi_parse(lmsg);
    dlog(9,lmsg);
   }
  }
 }
}
/////###################
void timi_pause_toggle() { lf("timi_pause_toggle");
      if(timistate==3) { timistate=4; cs("===== PAUSE =====\n");
  do { oscp_timi_check_input(); } while(timistate==4);
 }
 else if(timistate==4) { timistate=3; cs("===== RESUME =====\n"); }
 else cs("Info: pause called but timistate != (3 || 4)"); }

/////##############
void timi_checksd() {}
/////##############
void timi_checkmd() {}

int timi_fd[2][3]={ {-1,-1,-1}, {-1,-1,-1} };



////##############################
int timi_slurp(char *buf, int len) { lf("timi_slurp");
 int i, ret=0, fd=timi_recv[1]; if(fd<0) { dlog(9, "timi_slurp: fd<0"); return 0; }

 fd_set fsa, fsr; struct timeval tv; tv.tv_sec=0; tv.tv_usec=1000*1000;
 FD_ZERO(&fsr); FD_ZERO(&fsa); FD_SET(fd, &fsa);
 ret=select(FD_SETSIZE, &fsa, NULL, NULL, &tv);

 if(ret<0) { dlog(9, "timi_slurp: ret<0"); }
 else if(ret==0) { dlog(9, "timi_slurp: ret==0"); }
 else for(i=0; i<FD_SETSIZE; ++i) if(FD_ISSET(i, &fsa)) {
  if(i==fd) { usleep(10000); ret=read(fd, buf, len); break; }
 }

 return ret;
}
/////###########
void timi_play() { lf("timi_play"); dlog(9, "timi_play");
 if(timistate!=3) { cs("EOF code: can't play, not inited\n"); return; }
 float ot1=-7.0, ts;

 static char lmsg[128]; void *buf[1]; int gb;

 while(timistate==3 && (gb=timi_slurp(timi_dbuf, timi_dbuf_size))>0)
 {
  ts=((float)gb)/sformat.rate/sformat.channels/2.0;
  timicur+=ts; if((int)timicur!=(int)ot1)
  { ot1=timicur; sprintf(lmsg, "A: %.1f 0 0 0 0 0 0 0\n", timicur); cs(lmsg); }

  buf[0]=timi_dbuf; adev_out(buf, gb/2/sformat.channels, sformat.channels, sfmt);

  timii++; timi_check_input();
  if(timicur>=timidurmax) timi_stop();
 }

 adev_close();
 timi_die("EOF code: finished decoding\n");
 lf("timi_play:finished");
}

/////########################
void oscp_timi_load(char *fn) { lf("oscp_timi_load");
 timi_load(fn); //timi_play();
 lf("oscp_timi_load:finished");
}
/////#####################
void oscp_timi_seek(int a) { lf("oscp_timi_seek"); if(a<=0) return;
 float ts=((float)timi_dbuf_size)/sformat.rate/sformat.channels/2.0; float s0=timicur; int db=0;
 while((db=timi_slurp(timi_dbuf, timi_dbuf_size))>0 && timicur<s0+a) { timicur+=ts; }
}
/////########################
void oscp_timi_parse(char *a) { lf("oscp_timi_parse"); char lmsg[4096];
// sprintf(lmsg,"ofparse start"); dlog(9,lmsg);
 int l=strlen(a); if(l<=0) { sprintf(lmsg,"ofparse: l==%d ?", l); dlog(9,lmsg); return; }
 if(strcmp(a,"q")==0 || strcmp(a,"quit")==0) { timi_end(); exit(0);
 } else if(strncmp(a,"loadfile ",9)==0) { oscp_timi_load(a+9);
 } else if(strncmp(a,"load ",5)==0) { oscp_timi_load(a+5);
 } else if(strncmp(a,"pause",5)==0) { timi_pause_toggle();
 } else if(strncmp(a,"get_property length",19)==0) {
  sprintf(lmsg, "ANS_length=%.1f\n", timidur); cs(lmsg);
 } else if(strncmp(a,"get_property time_pos",19)==0 || strncmp(a,"get_time_pos",12)==0) {
//  sprintf(lmsg, "A: %.1f 0 0 0 0 0 0 0 0 0\n", timicur); cs(lmsg);
 } else if(strncmp(a,"seek ",5)==0) { int o1=0;
  if(a[5]==*"-") { sscanf(a+6, "%d", &o1); o1*=-1; }
  else if(a[5]==*"+") { sscanf(a+6, "%d", &o1); }
  else { sscanf(a+5, "%d", &o1); }
  oscp_timi_seek(o1);
 } else if(strncmp(a,"vis ",4)==0) { sscanf(a+4, "%d", &vis);
 } else if(strncmp(a,"lfdump",5)==0) { lfdump();
 } else { sprintf(lmsg, "ofparse unhandled: %s", a); dlog(9, lmsg); }
 lf("oscp_timi_parse:finished");
}
/////####################### check stdin
void oscp_timi_check_input() { lf("oscp_timi_check_input");
 dlog(9,"oscp_timi_check_input");
 char lmsg[4096]; int i, rc; fd_set fsa;
 struct timeval *tvp=NULL; //, tv; tv.tv_sec=0; tv.tv_usec=10000*99; // i=(int)time(NULL);
 usleep(10000); FD_ZERO(&fsa);
 if(parent_said>=0) FD_SET(parent_said, &fsa);
 if(timi_recv2[1]>0) FD_SET(timi_recv2[1], &fsa);
 rc=select(FD_SETSIZE, &fsa, NULL, NULL, tvp); // block till input

 if(rc<0) { if(0) { exit(EXIT_FAILURE); } else usleep(10000*99); }
 else if(rc==0) { }
 else for(i=0; i<FD_SETSIZE; ++i) if(FD_ISSET(i, &fsa)) {
  if(i==parent_said) { dlog(9,"parent says"); fdreadline(i, lmsg, 1020);
   dlog(9,lmsg);   dlog(9,"parent says. done.");
  oscp_timi_parse(lmsg); }
  else if(i==timi_recv2[1]) {
dlog(9,"fork says");
 fdreadline(i, lmsg, 1020);
// oscp_timi_parse(lmsg);
   dlog(9,lmsg);
dlog(9,"fork says. done.");
//   cs(lmsg);
  }
 }
 lf("oscp_timi_check_input:finished");
 dlog(9,"oscp_timi_check_input:finished");
}
////################
int oscp_timi_main() { lf("oscp_timi_main");
 cs("oscp-slave fork_timidity++\n");
 lf("oscp_timi_main:timi_init");
 timi_init();
 lf("oscp_timi_main:while");
 while(1) { oscp_timi_check_input(); }
 lf("oscp_timi_main:timi_end");
 timi_end();
 lf("oscp_timi_main:finished");
 cs("EOF code: exit\n");
// lfdump();
 return 0;
}
