/*
 * oscp-slave-timi-wildmidi-0.4.0.c
 * Copyright (C) 2015 KotCzarny <tjosko@yahoo.com>
 *
 *  This program is free software; you can redistribute it and/or modify it
 *  under the terms of the GNU General Public License as published by the
 *  Free Software Foundation; either version 2 of the License, or (at your
 *  option) any later version.
 *
 *  This program is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */

#include "oscp-slave.h"

#include "wildmidi_lib.h"

int timic=0; midi *timis; struct _WM_Info *timiI;

#define timi_dbuf_size 1024*8
char timi_dbuf[timi_dbuf_size];

int timistate=0; float timicur=0, timidur=0; int timii=0;
int timisong=0; int timidurmax=5;
char timifn[PM];

/////################
void timi_show_supp() {
 printf("  [slave-timi]: based on libwildmidi-0.4.0");
 printf(", formats: mid, xmi\n");
}


/////###########
//void timi_flush() { lf("timi_flush"); adev_flush(); }


/////###########
void timi_init() { lf("timi_init"); timistate=0; dlog(9, "timi_init"); if(timistate>0) return;
 if(adev_init()<=0) { dlog(9,"timi_init: adev_init failed"); return; }

 uint16_t mixer_options = 0;
 uint8_t master_volume = 100;

// master_volume = (uint8_t) atoi(optarg);
// mixer_options |= WM_MO_REVERB;
// mixer_options |= WM_MO_ENHANCED_RESAMPLING;
// mixer_options |= WM_MO_LOG_VOLUME;

 char config_file[1024], mpd[PM], mpc[PM];
 sprintf(mpd, get_conf("midi_patch_dir")); if(mpd[0]==0) sprintf(mpd, ".");
 sprintf(mpc, get_conf("midi_patch_cfg")); if(mpc[0]==0) sprintf(mpc, "wildmidi.cfg");

if(0) strncpy(config_file, "wildmidi.cfg", 1023); else snprintf(config_file, 1023, "@@\n"
//"guspat_editor_author_cant_read_so_fix_release_time_for_me\n"
"dir %s\n"
"source %s\n", mpd, mpc
);
dlog(9,config_file);

 if(WildMidi_Init(config_file, 44100, mixer_options)<0) { dlog(9, "WildMidi_Init: failed"); return; }
 WildMidi_MasterVolume(master_volume);

 timic=1;

 timistate=1;
}
/////###########
void timi_stop() { lf("timi_stop");
 dlog(9, "timi_stop");
 if(timistate<=1) return;

 if(timistate>=3) { 
  WildMidi_Close(timis);
 }

 timistate=1;
}
/////##########
void timi_end() { lf("timi_end");
 dlog(9, "timi_end"); if(timistate>1) timi_stop(); adev_end();

 if(timic==1) WildMidi_Shutdown();
 timic=0;

 timistate=0; 
}
/////###################
void timi_die(char *msg) { lf2("timi_die",msg); dlog(9, "timi_die"); timi_stop(); cs(msg); }

char timifn[PATH_MAX]; int timifs=0;

int timi_last_patch=0;
#define timi_dirs_cnt 1+7
char timi_dirs[timi_dirs_cnt][16]={ ".",
//"hssynthe", //  0.2M
//"vindream", //  1.5M
"esb", //  1.8M
"pplt_150", //  4.2M
"dgguspat", //  5.6M
//"casiovl1", //  5.7M
"nokia30", // 9.8M
"timgm6mb", // 18.8M
"freepats", // 32.6M
"8mbgmpat",  // 31.4M
//"ff7",      // 29.2M
//"ff7enh",   //191.7M
//"ff8v1_31", // 47.2M
//"unison",   // 72.6M
//"32mbgmst", //214.8M
//"pc51f"    //304.4M
};

/////##########################
void timi_update_info(char *fn) { lf("timi_update_info");
 static char lmsg[4096];
 timiI=WildMidi_GetInfo(timis);
 timidur=timiI->approx_total_samples/44100;
 sprintf(lmsg, "ANS_length=%.1f\n", timidur); cs(lmsg);

 snprintf(lmsg, 4095, "Title: %s\n", get_bn2(fn)); cs(lmsg);
 snprintf(lmsg, 4095, "Comment: %d, %s\n", get_filesize(fn),
  get_basename(timi_last_patch<1?get_conf("midi_patch_dir"):timi_dirs[timi_last_patch])
//  (timi_last_patch<1?get_conf("midi_patch_dir"):timi_dirs[timi_last_patch])
 ); cs(lmsg);
}

void timi_play1();
/////#####################################################
void timi_load(char *input_filename0, long unsigned int t) { lfd("timi_load:state",timistate);
 static char lmsg[4096]; lmsg[4095]=0;
 snprintf(lmsg, 4095, "Playing %s\n", input_filename0); cs(lmsg);

 if(input_filename0[0]==0) return;
 if(input_filename0[0]==*"\"" && input_filename0[1]==*"\"" && input_filename0[2]==0)
 { cs("EOF code: stop requested\n"); if(timistate>2) timi_stop(); return; }

 if(timic==0) { timi_die("timi_load: wildmidi not inited properly\n"); return; }

 if(timistate==0) timi_init();
 else if(timistate>2) timi_stop();

 timistate=2; timicur=0; timidur=0;
 char *input_filename=input_filename0;


 timifs=get_filesize(input_filename);
 if(timifs<=0) { timi_die("timi_load: invalid module size\n"); return; }

 char *module=malloc(timifs); if(!timifs) { timi_die("timi_load: malloc failed\n"); return; }
 FILE *f=fopen(input_filename, "r"); if(!f) { timi_die("timi_load: fopen failed\n"); return; }
 fread(module, timifs, 1, f); fclose(f);

//WM_SYMBOL midi * WildMidi_Open (const char *midifile);
//WM_SYMBOL midi * WildMidi_OpenBuffer (uint8_t *midibuffer, uint32_t size);
 timis=WildMidi_OpenBuffer((uint8_t *)module, timifs);
 if(timis==NULL) { timi_die("EOF code: WildMidi_OpenBuffer failed\n"); if(0)timi_stop(); return; }

//  format.byte_format = AO_FMT_LITTLE;
 sfmt=AV_SAMPLE_FMT_S16;
      if(sfmt==AV_SAMPLE_FMT_U8 || sfmt==AV_SAMPLE_FMT_U8P){ sformat.bits=8; }
 else if(sfmt==AV_SAMPLE_FMT_S16 || sfmt==AV_SAMPLE_FMT_S16P){ sformat.bits=16; }
 else if(sfmt==AV_SAMPLE_FMT_S32 || sfmt==AV_SAMPLE_FMT_S32P){ sformat.bits=32; }
 else if(sfmt==AV_SAMPLE_FMT_FLT || sfmt==AV_SAMPLE_FMT_FLTP){ sformat.bits=32; }
 else if(sfmt==AV_SAMPLE_FMT_DBL || sfmt==AV_SAMPLE_FMT_DBLP){ sformat.bits=64; }
 else { timi_die("EOF code: Unsupported format\n"); return; }

 if(t>0) { WildMidi_FastSeek(timis, &t); }

 timiI=WildMidi_GetInfo(timis); timicur=(float)timiI->current_sample/44100.0;

// timicur=-1;
// timidur=timiInfo_GetDuration(timiI, timiInfo_GetDefaultSong(timiI))/1000.0;

 sformat.channels=2; sformat.rate=44100;
#ifdef LAO
 sformat.byte_format=AO_FMT_NATIVE; sformat.matrix=0;
#endif

 adev_setp(sformat.bits, &sformat.channels, &sformat.rate);
sprintf(lmsg, "AUDIO: %d Hz, %d ch, xxx, %d kbit\n", sformat.rate, sformat.channels, 0); cs(lmsg);

 timi_update_info(input_filename);

 timistate=3; timii=1;
 timi_play1();
}
void oscp_timi_check_input();
void oscp_timi_parse(char *a);
/////################# check messages
void timi_check_input() { lf("timi_check_input"); static char lmsg[4096]; static int rc;
 static fd_set timifsa;  static struct timeval timitv,*tvp;
 if(timistate==4) { tvp=NULL; }
 else { timitv.tv_sec=0; timitv.tv_usec=1; tvp=&timitv; }

 FD_ZERO(&timifsa); if(parent_said>=0) FD_SET(parent_said, &timifsa);

 rc=select(FD_SETSIZE, &timifsa, NULL, NULL, tvp); if(rc==0) return;
 else if(rc<0) { sprintf(lmsg, "Info: timici rc<0, %d, %s\n", errno, strerror(errno)); cs(lmsg); }
 else if(rc>0) // check if input is available
 { fdreadline(parent_said, lmsg, 1020); oscp_timi_parse(lmsg); }
}
/////###################
void timi_pause_toggle() { lf("timi_pause_toggle");
      if(timistate==3) { timistate=4; cs("===== PAUSE =====\n");
  do { oscp_timi_check_input(); } while(timistate==4);
 }
 else if(timistate==4) { timistate=3; cs("===== RESUME =====\n"); }
 else cs("Info: pause called but timistate != (3 || 4)"); }

/////##############
void timi_checksd() {}
/////##############
void timi_checkmd() {}

/////############
void timi_play1() { lf("timi_play1"); dlog(9, "timi_play1");
 if(timistate!=3) { cs("EOF code: can't play, not inited\n"); return; }
 float ot1=-77.0, ts=1.0/44100.0/2.0/2.0;

 static char lmsg[128]; void *buf[1]; buf[0]=timi_dbuf;
 int8_t *buf2=(int8_t *)timi_dbuf; int br;
 int trimsil=0;

 while(timistate==3 && (br=WildMidi_GetOutput(timis,buf2,timi_dbuf_size))>0)
 { //sprintf(lmsg, "ot1: %.2f, timicur: %.2f", ot1, timicur); dlog(9,lmsg);

  if((int)timicur!=(int)ot1)
  { ot1=timicur; sprintf(lmsg, "A: %.1f 0 0 0 0 0 0 0\n", timicur); cs(lmsg); }
  timicur+=br*ts;

  if(trimsil>=0) { int i; for(i=0;i<br;i++) if(timi_dbuf[i]!=0) {
   sprintf(lmsg, "timi_play1: trimmed %.2f s of silence from start", trimsil*ts); dlog(9,lmsg);
   trimsil=-1; break; } if(trimsil>=0) trimsil+=br; } else
  adev_out(buf, br/2/sformat.channels, sformat.channels, sfmt);

  timii++; timi_check_input();
 }

 adev_close();
 timi_die("EOF code: finished decoding\n");
 lf("timi1_play:finished");
}

/////########################
void oscp_timi_load(char *fn) { lf("oscp_timi_load");
 strncpy(timifn, fn, PM-1);
 timi_load(fn,0); //timi1_play();
 lf("oscp_timi_load:finished");
}
/////#####################
void oscp_timi_seek(int a) { lf("oscp_timi_seek"); unsigned long int t;
 timiI=WildMidi_GetInfo(timis); t=timiI->current_sample + (unsigned long int)a*44100; if(t<0) t=0;
 WildMidi_FastSeek(timis, &t);
 timiI=WildMidi_GetInfo(timis); timicur=(float)timiI->current_sample/44100.0;
}
/////########################
void timi_switch_patch(int a) {
 unsigned long int t; timiI=WildMidi_GetInfo(timis); t=timiI->current_sample;

 timi_end();
 timi_last_patch+=a;
 if(timi_last_patch>=timi_dirs_cnt) timi_last_patch=1;
 else if(timi_last_patch<1) timi_last_patch=timi_dirs_cnt-1;
 char b1[PM], b2[PM];
 snprintf(b1, PM-1, "%s/../%s", get_conf("midi_patch_dir"), timi_dirs[timi_last_patch]);
 realpath(b1, b2);

 set_confS("midi_patch_dir", b2);
 timi_init();

 timi_load(timifn, t);

/*
 WildMidi_FastSeek(timis, &t);
 timiI=WildMidi_GetInfo(timis); timicur=(float)timiI->current_sample/44100.0;

 char lmsg[1024];
 sprintf(lmsg, "Title: switched to patch #%d, timicur: %.2f\n", timi_last_patch, timicur); cs(lmsg);
 dlog(9,lmsg);
*/

}
/////########################
void oscp_timi_parse(char *a) { lf("oscp_timi_parse"); char lmsg[4096];
// sprintf(lmsg,"ofparse start"); dlog(9,lmsg);
 int l=strlen(a); if(l<=0) { sprintf(lmsg,"ofparse: l==%d ?", l); dlog(9,lmsg); return; }
 if(strcmp(a,"q")==0 || strcmp(a,"quit")==0) { timi_end(); exit(0);
 } else if(strncmp(a,"loadfile ",9)==0) { oscp_timi_load(a+9);
 } else if(strncmp(a,"load ",5)==0) { oscp_timi_load(a+5);
 } else if(strncmp(a,"pause",5)==0) { timi_pause_toggle();
 } else if(strncmp(a,"get_property length",19)==0) {
  sprintf(lmsg, "ANS_length=%.1f\n", timidur); cs(lmsg);
 } else if(strncmp(a,"get_property time_pos",19)==0 || strncmp(a,"get_time_pos",12)==0) {
//  sprintf(lmsg, "A: %.1f 0 0 0 0 0 0 0 0 0\n", timicur); cs(lmsg);
 } else if(strncmp(a,"seek ",5)==0) { int o1=0;
  if(a[5]==*"-") { sscanf(a+6, "%d", &o1); o1*=-1; }
  else if(a[5]==*"+") { sscanf(a+6, "%d", &o1); }
  else { sscanf(a+5, "%d", &o1); }
  oscp_timi_seek(o1);
 } else if(strncmp(a,"vis ",4)==0) { sscanf(a+4, "%d", &vis);
 } else if(strncmp(a,"trigger 1",9)==0) { timi_switch_patch(+1);
 } else if(strncmp(a,"trigger 2",9)==0) { timi_switch_patch(-1);
 } else if(strncmp(a,"lfdump",5)==0) { lfdump();
 } else { sprintf(lmsg, "ofparse unhandled: %s", a); dlog(9, lmsg); }
 lf("oscp_timi_parse:finished");
}

/////####################### check stdin
void oscp_timi_check_input() { lf("oscp_timi_check_input");
 char lmsg[4096]; int i, rc; fd_set fsa;
 struct timeval *tvp=NULL; //, tv; tv.tv_sec=0; tv.tv_usec=10000*99; // i=(int)time(NULL);
 usleep(10000); FD_ZERO(&fsa); if(parent_said>=0) FD_SET(parent_said, &fsa);
 rc=select(FD_SETSIZE, &fsa, NULL, NULL, tvp); // block till input

 if(rc<0) { if(0) { exit(EXIT_FAILURE); } else usleep(10000*99); }
 else if(rc==0) { }
 else for(i=0; i<FD_SETSIZE; ++i) if(FD_ISSET(i, &fsa)) {
  if(i==parent_said) { fdreadline(i, lmsg, 1020); oscp_timi_parse(lmsg); }
 }
 lf("oscp_timi_check_input:finished");
}
//FILE *flog;
////################
int oscp_timi_main() { lf("oscp_timi_main");
#ifdef TEST1
 conf.debug=9; dlog_init(); dlog(9,"HELLO WORLD");
// char lmsg[1024]; sprintf(lmsg, "conf.debug: %d, flog: %d\n", conf.debug, flog); cs(lmsg);
 parent_said=0; parent_ear=1;
#endif
 cs("oscp-slave libwildmidi-0.4.0\n");
 lf("oscp_timi_main:timi_init");
 timi_init();
#ifdef TEST1
 lf("oscp_timi_main:timi_load");
 #ifdef CYGWIN
  oscp_timi_load("/home/ariel/..src/1mod/mid/ame002.mid");
 #else
  oscp_timi_load("/1/_src/oscp-test-files/1mod/mid/wipeout.mid");
//  oscp_timi_load("/1/_src/oscp-test-files/1mod/mid/wipeout.mid");
 #endif
#else
 lf("oscp_timi_main:while");
 while(1) { oscp_timi_check_input(); }
#endif
 lf("oscp_timi_main:timi_end");
 timi_end();
 lf("oscp_timi_main:finished");
 cs("EOF code: exit\n");
// lfdump();
 return 0;
}
